- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
BlisObjectInt Class Reference

`#include <BlisObjectInt.h>`

Inheritance diagram for BlisObjectInt:
[legend]
Collaboration diagram for BlisObjectInt:
[legend]

## Public Member Functions
| BlisObjectInt ()
| Default Constructor. More...
| BlisObjectInt (int objectIndex, int iColumn, double lb, double ub, double breakEven=0.5)
| Useful constructor - passed integer index and model index. More...
virtual | ~BlisObjectInt ()
| Destructor. More...
| BlisObjectInt (const BlisObjectInt &)
| Copy constructor. More...
virtual BcpsObject * | clone () const
| Clone an object. More...
BlisObjectInt & | operator= (const BlisObjectInt &rhs)
| Assignment operator. More...
virtual double | infeasibility (BcpsModel *m, int &preferredWay) const
| Infeasibility. More...
virtual void | feasibleRegion (BcpsModel *m)
| Set bounds to contain the current solution. More...
virtual BcpsBranchObject * | createBranchObject (BcpsModel *m, int direction) const
| Creates a branching object. More...
virtual BcpsBranchObject * | preferredNewFeasible (BcpsModel *m) const
| Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in the good direction. More...
virtual BcpsBranchObject * | notPreferredNewFeasible (BcpsModel *m) const
| Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in a bad direction. More...
virtual void | resetBounds (BcpsModel *m)
| Reset original upper and lower bound values from the solver. More...
virtual int | columnIndex () const
| Column number if single column object, otherwise. More...
double | breakEven () const
| Breakeven e.g 0.7 -> >= 0.7 go up first. More...
void | setBreakEven (double value)
| Set breakeven e.g 0.7 -> >= 0.7 go up first. More...
BlisPseudocost & | pseudocost ()
| Access pseudocost. More...
| BlisObjectInt ()
| Default Constructor. More...
| BlisObjectInt (int objectIndex, int iColumn, double lb, double ub, double breakEven=0.5)
| Useful constructor - passed integer index and model index. More...
virtual | ~BlisObjectInt ()
| Destructor. More...
| BlisObjectInt (const BlisObjectInt &)
| Copy constructor. More...
virtual BcpsObject * | clone () const
| Clone an object. More...
BlisObjectInt & | operator= (const BlisObjectInt &rhs)
| Assignment operator. More...
virtual double | infeasibility (BcpsModel *m, int &preferredWay) const
| Infeasibility. More...
virtual void | feasibleRegion (BcpsModel *m)
| Set bounds to contain the current solution. More...
virtual BcpsBranchObject * | createBranchObject (BcpsModel *m, int direction) const
| Creates a branching object. More...
virtual BcpsBranchObject * | preferredNewFeasible (BcpsModel *m) const
| Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in the good direction. More...
virtual BcpsBranchObject * | notPreferredNewFeasible (BcpsModel *m) const
| Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in a bad direction. More...
virtual void | resetBounds (BcpsModel *m)
| Reset original upper and lower bound values from the solver. More...
virtual int | columnIndex () const
| Column number if single column object, otherwise. More...
double | breakEven () const
| Breakeven e.g 0.7 -> >= 0.7 go up first. More...
void | setBreakEven (double value)
| Set breakeven e.g 0.7 -> >= 0.7 go up first. More...
BlisPseudocost & | pseudocost ()
| Access pseudocost. More...
Get or set Original bounds.
double | originalLowerBound () const
void | setOriginalLowerBound (double value)
double | originalUpperBound () const
void | setOriginalUpperBound (double value)
double | originalLowerBound () const
void | setOriginalLowerBound (double value)
double | originalUpperBound () const
void | setOriginalUpperBound (double value)
Public Member Functions inherited from BcpsObject
| BcpsObject ()
| BcpsObject (double lbh, double ubh, double lbs, double ubs)
virtual | ~BcpsObject ()
| BcpsObject (const BcpsObject &rhs)
| Copy constructor. More...
BcpsObject & | operator= (const BcpsObject &rhs)
| Assignment operator. More...
virtual bool | boundBranch (BcpsModel *m) const
| Return true if branches created by object will modify variable bounds. More...
virtual void | floorCeiling (double &floorValue, double &ceilingValue, double value, double tolerance) const
| Returns floor and ceiling i.e. More...
virtual double | upEstimate () const
| Return "up" estimate. More...
virtual double | downEstimate () const
| Return "down" estimate. More...
virtual void | printDesc ()
virtual AlpsReturnStatus | encode (AlpsEncoded *encoded)
| Pack into a encode object. More...
virtual AlpsKnowledge * | decode (AlpsEncoded &encoded) const
| Decode a constraint from an encoded object. More...
int | getObjectIndex () const
| Return the value of the appropriate field. More...
BcpsObjRep_t | getRepType () const
| Return the value of the appropriate field. More...
BcpsIntegral_t | getIntType () const
| Return the value of the appropriate field. More...
BcpsValidRegion | getValidRegion () const
| Return the value of the appropriate field. More...
int | getStatus () const
| Return the value of the appropriate field. More...
double | getLbHard () const
| Return the value of the appropriate field. More...
double | getUbHard () const
| Return the value of the appropriate field. More...
double | getLbSoft () const
| Return the value of the appropriate field. More...
double | getUbSoft () const
| Return the value of the appropriate field. More...
int | getNumInactive () const
| Return the value of the appropriate field. More...
double | getEffectiveness () const
| Return the value of the appropriate field. More...
void | setObjectIndex (int ind)
| Set the appropriate property. More...
void | setRepType (BcpsObjRep_t rt)
| Set the appropriate property. More...
void | setIntType (BcpsIntegral_t it)
| Set the appropriate property. More...
void | setValidRegion (BcpsValidRegion val)
| Set the appropriate property. More...
void | setStatus (int st)
| Set the appropriate property. More...
void | setLbHard (double lb)
| Set the appropriate property. More...
void | setUbHard (double ub)
| Set the appropriate property. More...
void | setLbSoft (double lb)
| Set the appropriate property. More...
void | setUbSoft (double ub)
| Set the appropriate property. More...
void | setNumInactive (int num)
| Set the appropriate property. More...
void | setEffectiveness (double eff)
| Set the appropriate property. More...
virtual void | hashing (BcpsModel *model=NULL)
| Hashing. More...
double | hashValue () const
| Hashing. More...
Public Member Functions inherited from AlpsKnowledge
| AlpsKnowledge ()
virtual | ~AlpsKnowledge ()
KnowledgeType | getType ()
void | setType (KnowledgeType t)
virtual AlpsEncoded * | encode () const
| This method should encode the content of the object and return a pointer to the encoded form. More...
AlpsEncoded * | getEncoded () const
| Get/set encoded. More...
void | setEncoded (AlpsEncoded *e)

## Protected Attributes
int | columnIndex_
| Column index in the lp model. More...
double | originalLower_
| Original lower bound. More...
double | originalUpper_
| Original upper bound. More...
double | breakEven_
| Breakeven i.e. More...
BlisPseudocost | pseudocost_
| Pseudo cost. More...
Protected Attributes inherited from BcpsObject
int | objectIndex_
| Global index of this object. More...
BcpsObjRep_t | repType_
| Core, indexed, or algorithmic. More...
BcpsIntegral_t | intType_
| The integrality type of the object, i.e., what values it can take up between the specified bounds. More...
BcpsValidRegion | validRegion_
| Valid in the whole tree or only the subtree rooted at the node that generate this object. More...
int | status_
| The status of the object. More...
double | lbHard_
| The lower bound of the object when it was first created. More...
double | ubHard_
| The upper bound of the object when it was first created. More...
double | lbSoft_
| The current lower bound of the object. More...
double | ubSoft_
| The current upper bound of the object. More...
double | hashValue_
| The hash value of this object. More...
int | numInactive_
| Number of inactive when in formulation. More...
double | effectiveness_
| Effectiveness: nonnegative value. More...
Protected Attributes inherited from AlpsKnowledge
KnowledgeType | type_

## Additional Inherited Members
Protected Member Functions inherited from BcpsObject
AlpsReturnStatus | encodeBcpsObject (AlpsEncoded *encoded) const
| Pack Bcps part to a encode object. More...
AlpsReturnStatus | decodeBcpsObject (AlpsEncoded &encoded)
| Unpack Bcps part from a encode object. More...

## Detailed Description

Definition at line 36 of file BlisObjectInt.h.

## Constructor & Destructor Documentation

BlisObjectInt::BlisObjectInt | ( |  | ) |

Default Constructor.

BlisObjectInt::BlisObjectInt | ( | int | objectIndex,
|  | int | iColumn,
|  | double | lb,
|  | double | ub,
|  | double | breakEven = `0.5`
| ) |  |

Useful constructor - passed integer index and model index.

virtual BlisObjectInt::~BlisObjectInt | ( |  | ) |
| inline virtual

Destructor.

Definition at line 68 of file BlisObjectInt.h.

BlisObjectInt::BlisObjectInt | ( | const BlisObjectInt & |  | ) |

Copy constructor.

BlisObjectInt::BlisObjectInt | ( |  | ) |

Default Constructor.

BlisObjectInt::BlisObjectInt | ( | int | objectIndex,
|  | int | iColumn,
|  | double | lb,
|  | double | ub,
|  | double | breakEven = `0.5`
| ) |  |

Useful constructor - passed integer index and model index.

virtual BlisObjectInt::~BlisObjectInt | ( |  | ) |
| inline virtual

Destructor.

Definition at line 68 of file BlisObjectInt.h.

BlisObjectInt::BlisObjectInt | ( | const BlisObjectInt & |  | ) |

Copy constructor.

## Member Function Documentation

virtual BcpsObject* BlisObjectInt::clone | ( |  | ) | const
| inline virtual

Clone an object.

Reimplemented from BcpsObject.

Definition at line 74 of file BlisObjectInt.h.

BlisObjectInt& BlisObjectInt::operator= | ( | const BlisObjectInt & | rhs | ) |

Assignment operator.

virtual double BlisObjectInt::infeasibility | ( | BcpsModel * | m,
|  | int & | preferredWay
| ) |  | const
| virtual

Infeasibility.

Range is [0.0, 0.5].

Parameters

  PreferredWay | the direction close to an integer.

Reimplemented from BcpsObject.

virtual void BlisObjectInt::feasibleRegion | ( | BcpsModel * | m | ) |
| virtual

Set bounds to contain the current solution.

More precisely, for the variable associated with this object, take the value given in the current solution, force it within the current bounds if required, then set the bounds to fix the variable at the integer nearest the solution value.

Reimplemented from BcpsObject.

virtual BcpsBranchObject* BlisObjectInt::createBranchObject | ( | BcpsModel * | m,
|  | int | direction
| ) |  | const
| virtual

Creates a branching object.

Reimplemented from BcpsObject.

virtual BcpsBranchObject* BlisObjectInt::preferredNewFeasible | ( | BcpsModel * | m | ) | const
| virtual

Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in the good direction.

The preferred branching object will force the variable to be +/-1 from its current value, depending on the reduced cost and objective sense. If movement in the direction which improves the objective is impossible due to bounds on the variable, the branching object will move in the other direction. If no movement is possible, the method returns NULL.

Only the bounds on this variable are considered when determining if the new point is feasible.

Reimplemented from BcpsObject.

virtual BcpsBranchObject* BlisObjectInt::notPreferredNewFeasible | ( | BcpsModel * | m | ) | const
| virtual

Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in a bad direction.

As for preferredNewFeasible(), but the preferred branching object will force movement in a direction that degrades the objective.

Reimplemented from BcpsObject.

virtual void BlisObjectInt::resetBounds | ( | BcpsModel * | m | ) |
| virtual

Reset original upper and lower bound values from the solver.

Handy for updating bounds held in this object after bounds held in the solver have been tightened.

Reimplemented from BcpsObject.

virtual int BlisObjectInt::columnIndex | ( |  | ) | const
| inline virtual

Column number if single column object, otherwise.

Definition at line 129 of file BlisObjectInt.h.

double BlisObjectInt::originalLowerBound | ( |  | ) | const
| inline

Definition at line 133 of file BlisObjectInt.h.

void BlisObjectInt::setOriginalLowerBound | ( | double | value | ) |
| inline

Definition at line 134 of file BlisObjectInt.h.

double BlisObjectInt::originalUpperBound | ( |  | ) | const
| inline

Definition at line 135 of file BlisObjectInt.h.

void BlisObjectInt::setOriginalUpperBound | ( | double | value | ) |
| inline

Definition at line 136 of file BlisObjectInt.h.

double BlisObjectInt::breakEven | ( |  | ) | const
| inline

Breakeven e.g 0.7 -> >= 0.7 go up first.

Definition at line 140 of file BlisObjectInt.h.

void BlisObjectInt::setBreakEven | ( | double | value | ) |
| inline

Set breakeven e.g 0.7 -> >= 0.7 go up first.

Definition at line 143 of file BlisObjectInt.h.

BlisPseudocost& BlisObjectInt::pseudocost | ( |  | ) |
| inline

Access pseudocost.

Definition at line 146 of file BlisObjectInt.h.

virtual BcpsObject* BlisObjectInt::clone | ( |  | ) | const
| inline virtual

Clone an object.

Reimplemented from BcpsObject.

Definition at line 74 of file BlisObjectInt.h.

BlisObjectInt& BlisObjectInt::operator= | ( | const BlisObjectInt & | rhs | ) |

Assignment operator.

virtual double BlisObjectInt::infeasibility | ( | BcpsModel * | m,
|  | int & | preferredWay
| ) |  | const
| virtual

Infeasibility.

Range is [0.0, 0.5].

Parameters

  PreferredWay | the direction close to an integer.

Reimplemented from BcpsObject.

virtual void BlisObjectInt::feasibleRegion | ( | BcpsModel * | m | ) |
| virtual

Set bounds to contain the current solution.

More precisely, for the variable associated with this object, take the value given in the current solution, force it within the current bounds if required, then set the bounds to fix the variable at the integer nearest the solution value.

Reimplemented from BcpsObject.

virtual BcpsBranchObject* BlisObjectInt::createBranchObject | ( | BcpsModel * | m,
|  | int | direction
| ) |  | const
| virtual

Creates a branching object.

Reimplemented from BcpsObject.

virtual BcpsBranchObject* BlisObjectInt::preferredNewFeasible | ( | BcpsModel * | m | ) | const
| virtual

Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in the good direction.

The preferred branching object will force the variable to be +/-1 from its current value, depending on the reduced cost and objective sense. If movement in the direction which improves the objective is impossible due to bounds on the variable, the branching object will move in the other direction. If no movement is possible, the method returns NULL.

Only the bounds on this variable are considered when determining if the new point is feasible.

Reimplemented from BcpsObject.

virtual BcpsBranchObject* BlisObjectInt::notPreferredNewFeasible | ( | BcpsModel * | m | ) | const
| virtual

Given a valid solution (with reduced costs, etc.), return a branching object which would give a new feasible point in a bad direction.

As for preferredNewFeasible(), but the preferred branching object will force movement in a direction that degrades the objective.

Reimplemented from BcpsObject.

virtual void BlisObjectInt::resetBounds | ( | BcpsModel * | m | ) |
| virtual

Reset original upper and lower bound values from the solver.

Handy for updating bounds held in this object after bounds held in the solver have been tightened.

Reimplemented from BcpsObject.

virtual int BlisObjectInt::columnIndex | ( |  | ) | const
| inline virtual

Column number if single column object, otherwise.

Definition at line 129 of file BlisObjectInt.h.

double BlisObjectInt::originalLowerBound | ( |  | ) | const
| inline

Definition at line 133 of file BlisObjectInt.h.

void BlisObjectInt::setOriginalLowerBound | ( | double | value | ) |
| inline

Definition at line 134 of file BlisObjectInt.h.

double BlisObjectInt::originalUpperBound | ( |  | ) | const
| inline

Definition at line 135 of file BlisObjectInt.h.

void BlisObjectInt::setOriginalUpperBound | ( | double | value | ) |
| inline

Definition at line 136 of file BlisObjectInt.h.

double BlisObjectInt::breakEven | ( |  | ) | const
| inline

Breakeven e.g 0.7 -> >= 0.7 go up first.

Definition at line 140 of file BlisObjectInt.h.

void BlisObjectInt::setBreakEven | ( | double | value | ) |
| inline

Set breakeven e.g 0.7 -> >= 0.7 go up first.

Definition at line 143 of file BlisObjectInt.h.

BlisPseudocost& BlisObjectInt::pseudocost | ( |  | ) |
| inline

Access pseudocost.

Definition at line 146 of file BlisObjectInt.h.

## Member Data Documentation

int BlisObjectInt::columnIndex_
| protected

Column index in the lp model.

Definition at line 41 of file BlisObjectInt.h.

double BlisObjectInt::originalLower_
| protected

Original lower bound.

Definition at line 44 of file BlisObjectInt.h.

double BlisObjectInt::originalUpper_
| protected

Original upper bound.

Definition at line 47 of file BlisObjectInt.h.

double BlisObjectInt::breakEven_
| protected

Breakeven i.e.

>= this preferred is up.

Definition at line 50 of file BlisObjectInt.h.

BlisPseudocost BlisObjectInt::pseudocost_
| protected

Pseudo cost.

Definition at line 53 of file BlisObjectInt.h.

The documentation for this class was generated from the following files:

- /tmp/CHiPPS-Blis-0.94.3/Bcps/examples/Blis/BlisObjectInt.h
- /tmp/CHiPPS-Blis-0.94.3/Blis/src/BlisObjectInt.h